︠ebf55857-6ae3-4e39-8b8e-4ea89f705a44︠
%html
<h1><center>Pollard's Rho Attack</center></h1>
︡cf5f7eaf-ea72-4d07-bb7c-280914991225︡{"done":true,"html":"<h1><center>Pollard's Rho Attack</center></h1>"}
︠04e334aa-ee9c-478c-845c-8425c45fcdf9i︠
%md
<b>Description.</b> The RhoAttack procedure uses two inputs - the modulus R and the number of rounds that we choose to run the algorithm. The initial value used in the procedure is $x_0=2$ and the function f used to generate the sequence $x_i$ is $f(x)=x^2+2$. The Floyd's cycle finding algorithm is incorporated in the procedure.
︡e92eda11-edbb-439e-a1bb-585f257d5bb3︡{"done":true,"md":"<b>Description.</b> The RhoAttack procedure uses two inputs - the modulus R and the number of rounds that we choose to run the algorithm. The initial value used in the procedure is $x_0=2$ and the function f used to generate the sequence $x_i$ is $f(x)=x^2+2$. The Floyd's cycle finding algorithm is incorporated in the procedure."}
︠93e50ec6-f213-4c89-a954-550087e5940cs︠
def RhoAttack(R,rounds):
    a=2
    b=2
    for i in range (1,rounds):
        a=(a^2+1)% R ######## Floyd's Cycle Finding
        c=(b^2+1)% R ######## Floyd's Cycle Finding
        b=(c^2+1)% R ######## Floyd's Cycle Finding
        g=gcd(a-b,R)
        if (1<g and g<R):
                print ("Factor found in round {0}".format(i))
                return(g)
    print("The Pollard rho failed in {0}rounds".format(rounds))
︡8e8a0116-93d1-4ea9-84c3-8abb2f05628d︡{"done":true}
︠8e91886d-12f2-4798-9ca0-ed0c721622c3︠

R=129646944724184073871 ######## R is the modulus
p=RhoAttack(R,200000) ########## 200000 rounds
print('p=',p) ################## The prime p was found using Pollard's Rho Attack
print('q=',R/p) ################ The prime q is R/p since R is a product of two primes
︡804e89f0-06f8-4464-b71e-7ba53bb885d9︡{"stdout":"Factor found in round 57290"}︡{"stdout":"\n"}︡{"stdout":"p= 3458734771\n"}︡{"stdout":"q= 37483922101\n"}︡{"done":true}
︠c30410ef-9284-4264-8d0b-88eed18365ad︠









